#include "std.h"
#include <stdlib.h>

const int MAX_SIZE_SEGMENT = 200000;

bool test (int size, const char* data)
{
    setDataStream (size, data);
    
    int nsizePrevTag = -1;
    int nsizeThisTag = -1;
    long prevTimestamp = 0;
    while (size > 0)
    {
        nsizePrevTag = GET(32);
        if ((nsizeThisTag!=-1) && (nsizePrevTag!=nsizeThisTag))
            return false;
        CMP (2, 0);
        SKIP (1);
        int type = GET (5);
        if (! IS_VALID ())
            return true;
        if (! ((type==8) || (type==9) || (type==18)))
            return false;
        nsizeThisTag = GET(24)+11;
        if (! IS_VALID ())
            return true;
        if (nsizeThisTag > MAX_SIZE_SEGMENT)
            return false;
        long timestamp = GET(24);
        long timestampEx = GET(8);
        timestamp += timestampEx*0x1000000;
        //if (IS_VALID())
        //    if (prevTimestamp > timestamp)
        //        return;
        prevTimestamp = timestamp;

        CMP (24,0x000000);
        if (IS_VALID() && type==9)
        {
            int type = GET (4);
            int codec = GET (4);
            if (! IS_VALID ())
                return true;

            if (type < 1)
                return false;
            if (type > 5)
                return false;
            if (codec < 2)
                return false;
            if (codec > 7)
                return false;
            if (codec==7)
            {
                int avctype = GET (8);
                int comp = GET (24);
                if (! IS_VALID ())
                    return true;

                if (avctype > 2)
                    return false;
                if (avctype!=1)
                    if (comp!=0)
                        return false;
            }
        }
        ::g_extraInfo = max (::g_extraInfo, nsizeThisTag+4);
        size -= nsizeThisTag + 4; 
        data += nsizeThisTag + 4;
        setDataStream (size, data);
    }
    return true;
}


int main (int argc, const char* argv[])
{
    assert (argc >= 5);
    bool testResult = false;

    stdOutput_e out = errOpen;
    if (parseAndValidate  (argc, argv))
    {
        out = fail;
        int sizeOfData;
        const char* data;
        getData (sizeOfData, data);
        for (int i = 0; i < g_maxCountOfTests; i++)
        {
            if (testResult = test (g_sizeofTestedData, data+i))
            {
                out = success;
                break;
            }
        }
    }

    stdOutput (out);
    
    return testResult ? EXIT_SUCCESS : EXIT_FAILURE;
}
