#include "std.h"

const int MAX_SEGMENT_SIZE=4100;
const int MIN_SEGMENT_SIZE=2000;
/*
bool test (int size, const char* data)
{
    setDataStream (size, data);
    __int64 prevVideoSCR[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
    while (size > 0)
    {
        //int bPUStart,PID,bAFExist,bPExist;

        // Partial Program Stream Pack header:
        int cod = GET (32);
        if (! IS_VALID ())
            return false;
        if (cod == 0x000001BA) //PSM
        {
            __int64 SCR = 0;
            SKIP (2);
            SCR |= GET(3) << 30;
            SKIP (1);
            SCR |= GET(15) << 15;
            SKIP (1);
            SCR |= GET (15) << 0;
            SKIP (1);
            int SCREx = GET (9);
            SKIP (1);
            SCR *= 300;
            SCR |= SCREx;
            if (! IS_VALID ())
                return true;
            SKIP(16);
            int testedByte = ::get(16) & 0x00ff;
            if (testedByte)
            {
                SKIP(8);
                int step = GET(3);
                if (! IS_VALID ())
                    return true;
                SKIP(5);
                SKIP(8*step);
            }
            else
            {
                // :)
            }

            cod = GET(32);
            if (! IS_VALID ())
                return true;
            if (        cod == 186+256 // null
                        ||  cod == 187+256 // system
                        ||  cod == 188+256 // psm
                        ||  cod == 189+256 // PES private stream 1
                        ||  cod == 190+256 // pes padding
                        ||  cod == 191+256 // PES private stream 2
                        ||  (cod >= 192+256 && cod <= 223+256) // pes audio
                      //||  (cod >= 224+256 && cod <= 239+256) // pes video.. tested later
                        ||  (cod >= 240+256 && cod <= 256+255) // pes data
                        )
                goto end_cycle;
            
            if (cod >= 224+256 && cod <=239+256)
            {
                int index = cod - (224+256);
                if (SCR <= prevVideoSCR[index])
                    return false;
                prevVideoSCR[index] = SCR;
                goto end_cycle;
            }
            return false;

        }
        else if ((cod == 0x000001B9) && (size<=4))
            return true;
        else
            return false;
end_cycle:
        size -= 2044;
        data += 2044;
        setDataStream (size, data);    
        if (::get(32)!=0x000001BA)
        {
            size -= 4;
            data += 4;
            setDataStream (size, data);
        }
    }

    return true;
}*/


bool testHeader (int size, const char* data, __int64& inout_prevVideoSCR)
{
    if (size < 0)
        return true;
    setDataStream (size, data);
    int cod = GET (32);
    if (! IS_VALID ())
        return true;
    if (cod == 0x000001BA) //PSM
    {
        __int64 SCR = 0;
        SKIP (2);
        SCR |= GET(3) << 30;
        SKIP (1);
        SCR |= GET(15) << 15;
        SKIP (1);
        SCR |= GET (15) << 0;
        SKIP (1);
        int SCREx = GET (9);
        SKIP (1);
        SCR *= 300;
        SCR |= SCREx;
        if (! IS_VALID ())
            return true;
        SKIP(16);
        int testedByte = ::get(16) & 0x00ff;
        if (testedByte)
        {
            SKIP(8);
            int step = GET(3);
            if (! IS_VALID ())
                return true;
            SKIP(5);
            SKIP(8*step);
        }
        else
        {
            // :)
        }

        cod = GET(32);
        if (! IS_VALID ())
            return true;
        if (        cod == 186+256 // null
                    ||  cod == 187+256 // system
                    ||  cod == 188+256 // psm
                    ||  cod == 189+256 // PES private stream 1
                    ||  cod == 190+256 // pes padding
                    ||  cod == 191+256 // PES private stream 2
                    ||  (cod >= 192+256 && cod <= 223+256) // pes audio
                  //||  (cod >= 224+256 && cod <= 239+256) // pes video.. tested later
                    ||  (cod >= 240+256 && cod <= 256+255) // pes data
                    )
            return true;
        
        if (cod >= 224+256 && cod <=239+256)
        {
            int index = cod - (224+256);
            if (SCR <= inout_prevVideoSCR)
                return false;
            inout_prevVideoSCR = SCR;
            return true;
        }
        return false;
    }
    return false;
}

bool test (int size, const char* data)
{
    //setDataStream (size, data);
    //__int64 prevVideoSCR[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
    __int64 prevVideoSCR = 0;
    if (! testHeader (size, data, prevVideoSCR))
        return false;

    while (size > 0)
    {
        bool result = false;
        for (int i = MIN_SEGMENT_SIZE; i <= MAX_SEGMENT_SIZE; i++)
        {
            if (result = testHeader (size-i, data+i, prevVideoSCR))
            {
                ::g_extraInfo = max (::g_extraInfo, i);
                size -= i;
                data += i;
                break;
            }
        }
        if (! result)
            return false;
    }

    return true;
}


int main (int argc, const char* argv[])
{
    assert (argc >= 5);
    bool testResult = false;

    stdOutput_e out = errOpen;
    if (parseAndValidate  (argc, argv))
    {
        out = fail;
        int sizeOfData;
        const char* data;
        getData (sizeOfData, data);
        for (int i = 0; i < g_maxCountOfTests; i++)
        {
            if (testResult = test (g_sizeofTestedData, data+i))
            {
                out = success;
                break;
            }
        }
    }

    stdOutput (out);
    
    return testResult ? EXIT_SUCCESS : EXIT_FAILURE;
}
