#include "std.h"

bool test (int size, const char* data)
{
    ::setDataStream (size, data);
    while (size > 0)
    {
        int bPUStart,PID,bAFExist,bPExist;

        // Partial Transport Steam:
        CMP (8, 0x47);
        if (! IS_VALID ())
            return true;
        if (IS_VALID () && ! GET(1)) // check error
        {
            bPUStart = GET(1);
            SKIP(1);
            PID = GET(13);
            SKIP(2);
            bAFExist = GET(1);
            bPExist = GET(1);
            SKIP(4);
            if (!IS_VALID ())
                return true;
            //Adaptation field:
            if (bAFExist)
            {
                int AFSize = GET (8);
                SKIP (AFSize*8);
            }

            if (PID==0x1FFF) //NULL_PACKET
            {
            }
            else if (PID==0 && bPUStart) //PAT/PMT
            {
                int table_id = GET(8);
                if (! IS_VALID ())
                    return true;
                if (table_id==0) // PAT:
                {
                    SKIP(1);
                    CMP(1,0);
                    SKIP(2);
                    CMP(2,0);
                    //int len = GET(10);
                    //if (len > 1021)
                    //    return false;
                }
                else if(table_id==2)
                {
                    SKIP(1);
                    CMP (3,3);
                    CMP (2,0);
                    if (! IS_VALID ())
                        return true;
                    int len = GET(10);
                    //if (len > 1021)
                    //    return;
                    len = GET(16);
                    //if (len > 1016)
                    //    return;
                    SKIP (2);
                    SKIP (5);
                    SKIP (1);
                    CMP (16,0);
                    //SKIP(3+13+4);
                    //CMP (2, 0);
                }
                else
                {
                    return false;
                }
            }
            else if (PID==1 && bPUStart)
            {
                int table_id = GET(8);
                SKIP(1);
                CMP(1,0);
                SKIP(2);
                CMP(2,0);
                //int len = GET(10);
                //if (len > 1021)
                //    return false;
            }
        }
    
        size -= 188; 
        data += 188;
        ::setDataStream (size, data);

        ::g_extraInfo = max (::g_extraInfo, 188);

        
        //if (size > 188)
        //    continue;
    }

    return true;
}


int main (int argc, const char* argv[])
{
    assert (argc >= 5);
    bool testResult = false;

    stdOutput_e out = errOpen;
    if (parseAndValidate  (argc, argv))
    {
        out = fail;
        int sizeOfData;
        const char* data;
        getData (sizeOfData, data);
        for (int i = 0; i < g_maxCountOfTests; i++)
        {
            if (testResult = test (g_sizeofTestedData, data+i))
            {
                out = success;
                break;
            }
        }
    }

    stdOutput (out);
    
    return testResult ? EXIT_SUCCESS : EXIT_FAILURE;
}