#pragma once

#include <stdlib.h>
#include <vector>
#include <assert.h>
#include <windows.h>

// velkost pamate, ktora musela byt nacitana, aby bolo mozne vykonat test 
// (ak vo vsetkych testoch je zamietnuty test hned v 1. bajte, tato premenna bude mat hodnotu 1)
int g_maxTestedSize = 0;

// kolko pamate bolo nacitanych
int g_sizeofLoadedData = 0;

// nacitane data
char* g_loadedData = NULL;

// kolko testov ma byt vykonanych (1. test je vykonany od 0. bajtu, 2. test od 1. bajtu...)
int g_maxCountOfTests = 0;

// kolko bajtov ma byt max spracovanych pri teste
int g_sizeofTestedData = 0;

// ma vypisovat rozsireny vypis
bool g_extendedOutput = true;

// extra informacia
int g_extraInfo = 0;

// nazov suboru, ktory sa ma spracovat:
std::string g_inputFile;



//const char* g_streamDataBegin = NULL;
const char* g_streamData;
int g_streamCountBytes;
int g_streamBitoffset;
void move (int bits_count)
{
    if (g_streamCountBytes <= 0)
        return;
    g_streamBitoffset += bits_count; 
    g_streamCountBytes -= g_streamBitoffset/8; 
    g_streamData += g_streamBitoffset/8;
    g_streamBitoffset %= 8;
    g_maxTestedSize = max (g_maxTestedSize, g_sizeofTestedData-g_streamCountBytes+1);
}

bool cmp (int bits_count,int value)
{ 
    if (g_streamCountBytes <= 0)
        return true;
    for (int i = g_streamBitoffset, j = 0; i < bits_count+g_streamBitoffset; i++, j++) 
    {
        char byte1 = g_streamData[i/8];
        char bit1 = (byte1 >> (7-(i%8)))&1;
        char bit2 = (value >> (bits_count-1-j))&1;
        if (bit1 != bit2) 
            return false;
    }
    return true;
}

int get (int bits_count)
{
    assert (bits_count <= 32);
    int value = 0;
    for (int i = g_streamBitoffset; i < bits_count+g_streamBitoffset; i++)
    {
        char byte1 = g_streamData[i/8];
        char bit1 = (byte1 >> (7-(i%8)))&1;
        value = (value << 1) + bit1;
    }
    return value;
}

bool cmp_move (int bits_count,int value)
{
    if (bits_count > g_streamCountBytes*8+(8-g_streamBitoffset)) // nie je co porovnavat
    {
        g_streamCountBytes = -1;
        return true;
    }
    bool bret = cmp (bits_count, value);
    move (bits_count);
    return bret;
}


int get_move (int bits_count)
{
    if (bits_count > g_streamCountBytes*8+(8-g_streamBitoffset)) // nie je co porovnavat
    {
        g_streamCountBytes = -1;
        return true;
    }
    int value = get (bits_count);
    move (bits_count);
    return value;
}

// je mozne citat zo streamu?
#define IS_VALID() (0 <= g_streamCountBytes*8+(8-g_streamBitoffset))
// ziska $count_bits$ bitov z dat
#define GET(count_bits) (get_move(count_bits))
// preskoci $count_bits$ bitov z dat
#define SKIP(count_bits) (move(count_bits))
// porovna prvych $count_bits$ bitov z dat s hodnotou value (ak sa porovnava 7 bitov, z value je pouzitych 7 najmenej dolezitych bitov)
#define CMP(count_bits,value) {if (! cmp_move(count_bits,value))return false;}


char* readData (const char* path, int offset, int loadBytes)
{
    HANDLE m_handle;

    m_handle = (HANDLE) ::CreateFile (path,      
                      GENERIC_READ,           // Open for reading
                      0,                      // Do not share
                      NULL,                   // No security
                      OPEN_EXISTING,          // Existing file only
                      FILE_ATTRIBUTE_NORMAL,  // Normal file
                      NULL); 
    if (m_handle == INVALID_HANDLE_VALUE)
    {
        return NULL;
    }
    
    DWORD high, low;
    low = ::GetFileSize (m_handle, &high);
    if ((! high) && (low < (unsigned)offset+loadBytes))
    {
        return NULL;
    }
    
    ::SetFilePointer (m_handle, offset, NULL, FILE_BEGIN);

    char* data = new char [loadBytes];
    DWORD readBytes;
    if (! ::ReadFile (m_handle, data, loadBytes, &readBytes, NULL))
    {
        return NULL;
    }

    ::CloseHandle (m_handle);
    return data;
}


/**
  0.param - cesta k aplikacii
  1.param - cesta k suboru
  2.param - offset, na ktorom zacne program citat
  3.param - kolko testov bude vykonanych
  4.param - aka velka oblast v pamati sa spracuje v jednom teste
  5.param - volitelny.. ak je 5. parameter(akykolvek), program bude vypisovat extra informacie
*/
bool parseAndValidate (int argc, const char* argv [])
{
    assert (argc >= 5);
    g_extendedOutput = (argc > 5);
    g_maxCountOfTests = atoi (argv[3]);
    g_maxTestedSize = 0;
    g_sizeofLoadedData = atoi(argv[4]) + atoi(argv[3])-1;
    g_sizeofTestedData = atoi (argv[4]);
    g_inputFile = argv[1];
    
    char* data;
    if (! (data = readData (argv[1], atoi(argv[2]), g_sizeofLoadedData)))
        return false;
    
    g_loadedData = data;

    return true;
}


void setDataStream (int size, const char* data)
{
    //g_streamDataBegin = data;
    g_streamData = data;
    g_streamCountBytes = size;
    g_streamBitoffset = 0;
}

enum stdOutput_e {errOpen, fail, success};
void stdOutput (stdOutput_e status)
{
    char* msg;
    switch (status)
    {
    case errOpen:
        msg="error";
        break;
    case fail:
        msg="fail";
        break;
    case success:
        msg="success";
        break;
    default:
        assert (0);
    }
    if (! g_extendedOutput)
        printf ("%s", msg);
    else
    {
        printf ("%s\t%s\t%d\t%d\n", ::g_inputFile.c_str(), msg, ::g_maxTestedSize, ::g_extraInfo);
    }
}

/*
void setOffsetOfStream (int size, const char* data)
{
    assert (g_streamDataBegin);
    g_streamData = data;
    g_streamCountBytes = size;
    g_streamBitoffset = 0;   
}*/

void getData (int& sizeOfData, const char*& data)
{
    sizeOfData = ::g_sizeofLoadedData;
    data = g_loadedData;
}