#include <windows.h>
#include <stdio.h>
#include <assert.h>




void ErrFileCannotBeOpened ()
{
    printf ("E");
    exit (-1);
}

void ErrFileTooSmall ()
{
    printf ("E");
    exit (-1);
}

void ErrFileCannotRead ()
{
    printf ("E");
    exit (-1);
}

char* ReadData (const char* path, int offset, int loadBytes)
{
    HANDLE m_handle;

    m_handle = (HANDLE) ::CreateFile (path,      
                      GENERIC_READ,           // Open for reading
                      0,                      // Do not share
                      NULL,                   // No security
                      OPEN_EXISTING,          // Existing file only
                      FILE_ATTRIBUTE_NORMAL,  // Normal file
                      NULL); 
    if (m_handle == INVALID_HANDLE_VALUE)
    {
        ErrFileCannotBeOpened ();
    }
    
    DWORD high, low;
    low = ::GetFileSize (m_handle, &high);
    if ((! high) && (low < offset+loadBytes))
    {
        ErrFileTooSmall ();
    }
    
    ::SetFilePointer (m_handle, offset, NULL, FILE_BEGIN);

    char* data = new char [loadBytes];
    DWORD readBytes;
    if (! ::ReadFile (m_handle, data, loadBytes, &readBytes, NULL))
    {
        ErrFileCannotRead ();
    }

    ::CloseHandle (m_handle);
    return data;
}

char* g_data;
int g_bytes = c_loadedBytes;
int g_bits_offset = 0;


void move (int bits_count)
{ 
    if (g_bytes <= 0)
        return;
    g_bits_offset += bits_count; 
    g_bytes -= g_bits_offset/8; 
    g_data += g_bits_offset/8;
    g_bits_offset %= 8;
}

bool cmp_big (int bits_count,int value)
{ 
    if (g_bytes <= 0)
        return true;
    for (int i = g_bits_offset, j = 0; i < bits_count+g_bits_offset; i++, j++) 
    {
        char byte1 = g_data[i/8];
        char bit1 = (byte1 >> (7-(i%8)))&1;
        char bit2 = (value >> (bits_count-1-j))&1;
        if (bit1 != bit2) 
            return false;
    }
    return true;
}

int get_big (int bits_count)
{
    assert (bits_count <= 32);
    int value = 0;
    for (int i = g_bits_offset; i < bits_count+g_bits_offset; i++)
    {
        char byte1 = g_data[i/8];
        char bit1 = (byte1 >> (7-(i%8)))&1;
        value = (value << 1) + bit1;
    }
    return value;
}

bool cmp_move_big (int bits_count,int value)
{
    if (bits_count > g_bytes*8+(8-g_bits_offset)) // nie je co porovnavat
    {
        g_bytes = -1;
        return true;
    }
    bool bret = cmp_big (bits_count, value);
    move (bits_count);
    return bret;
}


int get_move_big (int bits_count)
{
    if (bits_count > g_bytes*8+(8-g_bits_offset)) // nie je co porovnavat
    {
        g_bytes = -1;
        return true;
    }
    int value = get_big (bits_count);
    move (bits_count);
    return value;
}



bool cmp_little (int bits_count,int value)
{ 
    if (g_bytes <= 0)
        return true;
    for (int i = g_bits_offset, j = 0; i < bits_count+g_bits_offset; i++, j++) 
    {
        char byte1 = g_data[(bits_count-1-i)/8];
        char bit1 = (byte1 >> (7-(i%8)))&1;
        char bit2 = (value >> (bits_count-1-j))&1;
        if (bit1 != bit2) 
            return false;
    }
    return true;
}

int get_little (int bits_count)
{
    assert (bits_count <= 32);
    int value = 0;
    for (int i = g_bits_offset; i < bits_count+g_bits_offset; i++)
    {
        char byte1 = g_data[(bits_count-1-i)/8];
        char bit1 = (byte1 >> (7-(i%8)))&1;
        value = (value << 1) + bit1;
    }
    return value;
}

bool cmp_move_little (int bits_count,int value)
{
    if (bits_count > g_bytes*8+(8-g_bits_offset)) // nie je co porovnavat
    {
        g_bytes = -1;
        return true;
    }
    bool bret = cmp_little (bits_count, value);
    move (bits_count);
    return bret;
}


int get_move_little (int bits_count)
{
    if (bits_count > g_bytes*8+(8-g_bits_offset)) // nie je co porovnavat
    {
        g_bytes = -1;
        return true;
    }
    int value = get_little (bits_count);
    move (bits_count);
    return value;
}